package dinamiche;

import java.util.NoSuchElementException;

public class Queue<E>
{
	protected Nodo<E> primo, ultimo;
	protected int size;

	public Queue()
	{
		size = 0;
		primo = ultimo = null;
	}

	public int size()
	{
		return size;
	}

	public boolean isEmpty()
	{
		return size() == 0;
	}

	public boolean add(E element)
	{
		if(isEmpty())
		{
			primo = ultimo = new Nodo<E>(element, null);
		}
		else
		{
			Nodo<E> tmp = new Nodo<E>(element, null);
			ultimo.next = tmp;
			ultimo = tmp;
		}
		size++;
		return true;
	}

	public boolean offer(E element)
	{
		return add(element);
	}

	public E peek()
	{
		if(isEmpty())
		{
			return null;
		}
		return primo.getDato();
	}

	public E element()
	{
		E retval = peek();
		if(retval == null)
		{
			throw new NoSuchElementException("Coda vuota");
		}
		return retval;
	}

	public E poll()
	{
		if(isEmpty())
		{
			return null;
		}
		E retval = primo.getDato();
		if(size() == 1)
		{
			primo = ultimo = null;
		}
		else
		{
			primo = primo.getNext();
		}
		size--;
		return retval;
	}

	public E remove()
	{
		E retval = poll();
		if(retval == null)
		{
			throw new NoSuchElementException("Coda vuota");
		}
		return retval;
	}

	public void clear()
	{
		primo = ultimo = null;
		size = 0;
	}

	public boolean contains(Object o)
	{
		int i;
		if(o == null)
		{
			Nodo<E> tmp = primo;
			for(i=0;i<size();i++)
			{
				if(tmp.getDato() == null)
				{
					return true;
				}
				tmp = tmp.getNext();
			}
			return false;
		}
		else
		{
			Nodo<E> tmp = primo;
			for(i=0;i<size();i++)
			{
				if(o.equals(tmp.getDato()))
				{
					return true;
				}
				tmp = tmp.getNext();
			}
			return false;
		}


		/*
		if(isEmpty())
		{
			return false;
		}
		if(o == null)
		{
			Nodo<E> tmp = primo;
			while(tmp != null)
			{
				if(tmp.getDato() == null)
				{
					return true;
				}
				tmp = tmp.getNext();
			}
			return false;
		}
		else
		{
			Nodo<E> tmp = primo;
			while(tmp != null)
			{
				if(o.equals(tmp.getDato()))
				{
					return true;
				}
				tmp = tmp.getNext();
			}
			return false;
		}
		*/
	}

	public boolean equals(Queue<E> q)
	{
		if(size() != q.size())
		{
			return false;
		}

		Nodo<E> tmp1, tmp2;
		tmp1 = primo;
		tmp2 = q.primo;

		while(tmp1 != null)
		{
			E dtmp1 = tmp1.getDato();
			if(dtmp1 == null)
			{
				if(tmp2.getDato() != null)
				{
					return false;
				}
			}
			else
			{
				if(!dtmp1.equals(tmp2.getDato()))
				{
					return false;
				}
			}
			tmp1 = tmp1.getNext();
			tmp2 = tmp2.getNext();
		}
		return true;
	}

	public boolean remove(Object o)
	{
		if(isEmpty())
		{
			return false;
		}
		//if(size() == 1)
		//{
			if(o == null)
			{
				if(peek() == null)
				{
					remove();
					return true;
				}
			}
			else
			{
				if(o.equals(peek()))
				{
					remove();
					return true;
				}
			}
			//return false;
		//}
		Nodo<E> prev, curr;
		prev = primo;
		curr = primo.getNext();
		while(curr != null)
		{
			if(o == null)
			{
				if(curr.getDato() == null)
				{
					prev.setNext(curr.getNext());
					size--;
					if(curr.getNext() == null)
					{
						ultimo = prev;
					}
					return true;
				}
			}
			else
			{
				if(o.equals(curr.getDato()))
				{
					prev.setNext(curr.getNext());
					size--;
					if(curr.getNext() == null)
					{
						ultimo = prev;
					}
					return true;
				}
			}
			prev = curr;
			curr = curr.getNext();
		}
		return false;
	}
}
