package stack;

public class StackInt
{
	private int[] storage;
	private int head;

	/**
	*Creates an empty Stack of max 10 ints.
	*/
	public StackInt()
	{
		this(10);
	}

	/**
	*Creates an empty Stack of max N ints.
	*/
	public StackInt(int n)
	{
		storage = new int[n];
		head = 0;
	}


//Method Summary
	/**
	*Tests if this stack is empty.
	*/
	public boolean empty()
	{
		return head==0;
	}
	
	/**
	*Looks at the object at the top of this stack without removing it from the stack.
	*/
	public int peek()
	{
		if(empty())
		{
			throw new NoSuchElementException("Stack vuoto");
		}
		return storage[head-1];
	}
	
	/**
	*Removes the object at the top of this stack and returns that object as the value of this function.
	*/
	public int pop()
	{
		if(empty())
		{
			throw new NoSuchElementException("Stack vuoto");
		}

		/*
		int retval = storage[head-1];
		head = head-1;
		return retval;
		*/

		return storage[--head];
	}
	
	/**
	*Pushes an item onto the top of this stack.
	*/
	public int push(int item)
	{
		if(head == storage.length)
		{
			throw new StackFullException("Ho gia' " + head + " elementi");
		}
		storage[head++] = item;
		return item;
	}
	
	/**
	*Returns the 1-based position where an object is on this stack.
	*/
	public int search(int o)
	{
		int retval = -1;
		for(int i=head-1; i>=0;i--)
		{
			if(storage[i] == o)
			{
				retval = head - i;
				break;
			}
		}
		return retval;
	}

	/**
	*Returns the number of elements inside the Stack.
	*/
	public int howMany()
	{
		return head;
	}

	/**
	*Return a String representation of the Stack and its content.
	*/
	public String toString()
	{
		if(empty())
		{
			return "[]";
		}
		String retval = "[";
		for(int i = head-1;i > 0; i--)
		{
			retval = retval.concat(storage[i] + ", ");
		}
		retval = retval.concat(storage[0] + "]");
		return retval;
	}
}
