package stack;

public class StackStatico<E>
implements Stack<E>
{
	private E[] storage;
	private int head;

	/**
	*Creates an empty Stack of max 10 ints.
	*/
	public StackStatico()
	{
		this(10);
	}

	/**
	*Creates an empty Stack of max N ints.
	*/
	public StackStatico(int n)
	{
		storage = (E[])new Object[n];
		head = 0;
	}


//Method Summary
	/**
	*Tests if this stack is empty.
	*/
	public boolean empty()
	{
		return head==0;
	}
	
	/**
	*Looks at the object at the top of this stack without removing it from the stack.
	*/
	public E peek()
	{
		if(empty())
		{
			throw new NoSuchElementException("Stack vuoto");
		}
		return storage[head-1];
	}
	
	/**
	*Removes the object at the top of this stack and returns that object as the value of this function.
	*/
	public E pop()
	{
		if(empty())
		{
			throw new NoSuchElementException("Stack vuoto");
		}

		/*
		int retval = storage[head-1];
		head = head-1;
		return retval;
		*/

		return storage[--head];
	}
	
	/**
	*Pushes an item onto the top of this stack.
	*/
	public E push(E item)
	{
		if(item == null)
		{
			System.out.println("item e' di tipo null");
		}
		else
		{
			System.out.println("item e' di tipo " + item.getClass().getName());
		}
		if(head == storage.length)
		{
			throw new StackFullException("Ho gia' " + head + " elementi");
		}
		storage[head++] = item;
		return item;
	}
	
	/**
	*Returns the 1-based position where an object is on this stack.
	*/
	public int search(E o)
	{
		int retval = -1;
		for(int i=head-1; i>=0;i--)
		{
			if(storage[i].equals(o))
			{
				retval = head - i;
				break;
			}
		}
		return retval;
	}

	/**
	*Returns the number of elements inside the Stack.
	*/
	public int howMany()
	{
		return head;
	}

	/**
	*Return a String representation of the Stack and its content.
	*/
	public String toString()
	{
		if(empty())
		{
			return "[]";
		}
		String retval = "[";
		for(int i = head-1;i > 0; i--)
		{
			retval = retval.concat(storage[i] + ", ");
		}
		retval = retval.concat(storage[0] + "]");
		return retval;
	}
}
